declare function isEmail(str: string): boolean;

declare function replaceAt(str: string, index?: number, replaceStr?: string): string;

declare function insertAt(str: string, index?: number, insertStr?: string): string;

declare function capitalize(str: string): string;

declare function camelCase(str: string): string;

declare function pascalCase(str: string): string;

declare function arrayDiff(arr1: unknown[], arr2: unknown[]): unknown[];

/**
 * It generates a sequence of numbers starting at the first argument,
 * progressing by the third argument, and stopping at the second argument.
 *
 * @example
 *
 * range(0, 5) // [0, 1, 2, 3, 4, 5]
 * range(10, 50, 10) // [10, 20, 30, 40, 50]
 */
declare function range(start: number | undefined, stop: number, step?: number): number[];

declare function sleep(ms: number): Promise<void>;

declare function percentage(value: number, total: number, floor?: boolean): number;

declare function percentageOf(percentage: number, num: number, floor?: boolean): number;

declare function isNumber(value: unknown): boolean;

declare function inferType(str: string): string;

declare function setInObj(obj: object, path: string, value: unknown): object;

declare function getInObj(obj: object, path: string): unknown;

declare function isObjType(obj: unknown): boolean;

declare function cloneObj(obj: any): any;

export { arrayDiff, camelCase, capitalize, cloneObj, getInObj, inferType, insertAt, isEmail, isNumber, isObjType, pascalCase, percentage, percentageOf, range, replaceAt, setInObj, sleep };
